;Erweiterung der Ausgabe-Funktionalitt fr LCD fr AVR-Assembler (AT-Mega8).
;Dieser Include-Code ist Bestandteil LCD-Ausgaberoutinensammlung "print.inc".


;Die Datenausgaberoutine des LCD-Treibers sollte "lcd_data" heien.
;Das auszugebende ASCII-Zeichen steht im Register "tmp", das im Hauptprogramm
;eingerichtet werden muss.

;Es werden folgende Funktionen bereitgestellt,
;die per Macro aufgerufen werden:
;-----------------------------------------------------------------------------
;  printhex Reg         ;Gibt den Inhalt des Registers als zweistellige
                        ;Hex-Zahl aus. Enthlt das Register eine gepackte
                        ;BCD-Zahl, so werden die beiden Ziffern ausgegeben.
                        ;Somit erbrigt sich eine separate Routine zur
                        ;Ausgabe von Packed-BCD.
;-----------------------------------------------------------------------------
;  printbin Reg         ;Gibt den Inhalt des Registers als achtstelligen
                        ;Binr-Zahl aus.
;-----------------------------------------------------------------------------

.macro printhex ;Register
 mov tmp,@0                 ;Daten bernehmen
 rcall lcd_printhex         ;Aufruf...
.endmacro

.macro printbin ;Register
 mov tmp,@0                 ;Daten bernehmen
 rcall lcd_printbin         ;Aufruf...
.endmacro

;-----------------------------------------------------------------------------

lcd_printhex:           ;Wird von Makro aufgerufen. Gibt Byte als HEX aus.
 push tmp                   ;fr zweite Ziffer sichern
 swap tmp                   ;oberes Nibble zuerst
 rcall lcd_printhex1        ;ausgeben...
 pop tmp                    ;unteres Nibble
lcd_printhex1:          ;Nibble ausgeben
 andi tmp,15                ;nur unteres Nibble interessiert uns
 ori tmp,'0'                ;zur Ascii-Ziffer wandeln
 cpi tmp,'9'+1              ;Wert ber 9?
 brmi lcd_printhex2         ;nein, so lassen...
 subi tmp,-39               ;zum Kleinbuchstaben wandeln
; subi tmp,-7                ;zum Grobuchstaben wandeln
lcd_printhex2:
 rjmp lcd_data              ;Zeichen ausgeben und zurck...

lcd_printbin:   ;Wird von Makro aufgerufen. Gibt Byte als 8 BIN-Ziffern aus.
 push wh                    ;Reg sichern
 mov wh,tmp                 ;Wert nach wh
 sec                        ;gesetztes Carry als Ende-Indikator ins Register,
 rol wh                     ;oberstes Bit ins Carry schieben
lcd_printbin1:
 ldi tmp,'0'                ;erstmal Ziffer "0"
 adc tmp,null               ;Ziffer "1", falls Carry gesetzt war
 rcall lcd_data             ;Ziffer ausgeben
 lsl wh                     ;nchstes Bit ins Carry schieben
 brne lcd_printbin1         ;Indikator-Bit noch im Register? ja...
 pop wh                     ;Reg wiederherstellen
 ret                        ;zurck...

;-----------------------------------------------------------------------------
