;Erweiterung der Ausgabe-Funktionalitt fr LCD fr AVR-Assembler (AT-Mega8).
;Dieser Include-Code ist Bestandteil LCD-Ausgaberoutinensammlung "print.inc".


;Die Datenausgaberoutine des LCD-Treibers sollte "lcd_data" heien.
;Das auszugebende ASCII-Zeichen steht im Register "tmp", das im Hauptprogramm
;eingerichtet werden muss.

;Es werden folgende Funktionen bereitgestellt,
;die per Macro aufgerufen werden:
;-----------------------------------------------------------------------------
;  print8 Reg           ;Gibt den Inhalt von Reg. zweistellig aus,
                        ;wenn er kleiner als 100 ist. (Uhr)
                        ;Ab 100 erfolgt die Ausgabe dreistellig.
;-----------------------------------------------------------------------------
;  print8s Adr          ;Gibt den Inhalt von Adr (SRAM) zweistellig aus,
                        ;wenn er kleiner als 100 ist. (Uhr)
                        ;Ab 100 erfolgt die Ausgabe dreistellig.
;-----------------------------------------------------------------------------
;Verwendete Register:
; "xl" (wird gesichert)
; "tmp" (wird nicht gesichert)
;-----------------------------------------------------------------------------

.macro print8 ;Registername
                        ;Gibt Zahl im Register 2- oder 3-stellig aus.
                        ;Parameter bestimmt das Register, in dem die Zahl liegt.
                        ;Dieses Register wird nicht verndert.
                        ;Kopie der Zahl temporr in xl,
 mov tmp,@0                 ;Wert aus Register ins temp. SRAM
 rcall lcd_print8           ;Aufruf...
.endmacro               ;


.macro print8s ;Adresse im SRAM
                        ;Gibt Zahl im SRAM 2- oder 3-stellig aus.
                        ;Parameter bestimmt die Adresse im SRAM,
                        ;in dem die Zahl liegt.
                        ;Dieser Inhalt wird nicht verndert.
                        ;Kopie der Zahl temporr in tmp,
 lds tmp,@0                 ;Wert aus SRAM-Adresse holen
 rcall lcd_print8           ;Aufruf...
.endmacro               ;

;-----------------------------------------------------------------------------

lcd_print8:             ;Wird vom Makro aufgerufen.
                        ;Gibt Byte als 2 oder 3 Ziffern an LCD aus.
 push xl                    ;Reg sichern
 mov xl,tmp                 ;Datenwert kopieren
 ldi tmp,-1+'0'             ;Hunderter-Stelle als ASCII-Zeichen, Zahl ber 0
 inc tmp                    ;Hunderter hoch und
 subi xl,100                ;100 subtrahieren bis zum Unterlauf
 brsh pc-2                  ;Unterlauf? nein, 2 Zeilen hoch
 cpi tmp,'0'                ;ja, ist Ziffer = "0"?
 brne pc+2                  ;nein, ausgeben...
 ldi tmp,' '                ;ja, durch Leerzeichen ersetzen
 rcall lcd_data             ;Hunderter ausgeben...
 ldi tmp,10+'0'             ;Zehner-Stelle als ASCII-Zeichen, Zahl unter 0
 dec tmp                    ;Zehner runter und
 subi xl,-10                ;10 addieren bis zum berlauf
 brlo pc-2                  ;berlauf? nein, 2 Zeilen hoch...
 rcall lcd_data             ;ja, Zehner Stelle ausgeben...
 ldi tmp,'0'                ;ASCII-0
 add tmp,xl                 ;Einer addieren (Rest war ja ber 0)
 rcall lcd_data             ;Einer ausgeben...
 pop xl                     ;Reg wiederherstellen
 ret                        ;zurck

